proc zabber:connect {} {
global user jabber

  if {[catch {set sck [socket $user(serv) $user(port)]}] != 0} {
	tk_messageBox -message "Cannot connect to '$user(serv)' on port $user(port)."
	return -1
  }
  if {[jlib::connect $sck $user(serv)] != 0} {
	catch {close $sck}
	tk_messageBox -message "Cannot connect to '$user(serv)' on port $user(port)."
	return -1
  }
  set jabber(con) 1

  return 0
}

proc zabber:disconnect {} {
global jabber
  jlib::disconnect
  set jabber(con) 0
  return 0
}

proc zabber:login {pass} {
global user jabber

  if {$jabber(con) == 0} {return -1}

  set jabber(login) 0
  jlib::send_auth $user(uname) $pass $user(res) "zabber:login_cback"

  tkwait variable jabber(login)

  set a $jabber(login); set jabber(login) ""
  if {$a == 1} {return 0} else {return $a}
}

proc zabber:login_cback {type data} {
global jabber

  if {$type == "OK"} {set jabber(login) 1} \
    elseif {$type == "ERR"} {set jabber(login) [list [lindex $data 0] [lindex $data 1]]} \
    elseif {$type == "DISCONNECT"} {set jabber(login) -1}
}

proc zabber:create {user pass name mail} {
global jabber

  if {$jabber(con) == 0} {return -1}

  set jabber(create) 0
  jlib::send_create $user $pass $name $mail "zabber:create_cback"

  tkwait variable jabber(create)

  set a $jabber(create); set jabber(create) ""
  if {$a == 1} {return 0} else {return $a}
}

proc zabber:create_cback {type data} {
global jabber

  if {$type == "OK"} {set jabber(create) 1} \
    elseif {$type == "ERR"} {set jabber(create) [list [lindex $data 0] [lindex $data 1]]} \
    elseif {$type == "DISCONNECT"} {set jabber(create) -1}
}

proc zabber:set_pres {type} {
global user jabber pres

  if {$type == "type"} {
	if {$jabber(con) && $pres(show) == "offline"} {
		zabber:disconnect
		.win.f1.stat configure -text "Offline"
		return}
	if {!$jabber(con) && $pres(show) != "offline"} {
		.win.f1.stat configure -text "Connecting..."
		if {[zabber:connect] != 0} {
			.win.f1.stat configure -text "Offline"
			set pres(show) "offline"
			return}

		.win.f1.stat configure -text "Logging in..."

		if {[set a [zabber:login $user(pass)]] != 0} {
			if {$a != -1} {tk_messageBox -title "Cannot login!" -message "Error occured while logging in (Code:[lindex $a 0]):\n[lindex $a 1]"}
			.win.f1.stat configure -text "Offline"
			set pres(show) "offline"
			return}

		jlib::roster_get -command "client:roster"
		.win.m.roster entryconfigure 0 -state normal
		.win.m.roster entryconfigure 5 -state normal

		if {$pres(show) == "invisible"} {
			.win.f1.stat configure -text "Invisible"
			return
		}
	}

	if {$pres(show) == "invisible"} {
		jlib::send_presence -type "unavailable"
		.win.f1.stat configure -text "Invisible"
		return
	}

	jlib::send_presence \
		-stat $pres(stat) \
		-pri  $pres(pri)  \
		-meta $pres(meta) \
		-icon $pres(icon) \
		-show $pres(show) \
		-loc  $pres(loc)

	switch -- $pres(show) {
		online {.win.f1.stat configure -text "Online"}
		  away {.win.f1.stat configure -text "Away"}
		  busy {.win.f1.stat configure -text "Busy"}
		   dnd {.win.f1.stat configure -text "DND"}
	     invisible {.win.f1.stat configure -text "Invisible"}
	}
	return
  }
  if {$type == "icon" || $type == "pri"} {
	if {$jabber(con) && $pres(show) != "invisible"} {
		jlib::send_presence \
			-stat $pres(stat) \
			-pri  $pres(pri)  \
			-meta $pres(meta) \
			-icon $pres(icon) \
			-show $pres(show) \
			-loc  $pres(loc)
	}
	return
  }
}

proc zabber:getgroups {} {
global roster
  set groups ""
  foreach jid $roster(users) {
	foreach grp $roster(users,$jid) {
		if {[lsearch $groups $grp] == -1} {lappend groups $grp}
	}
  }
  return $groups
}

proc LOG {text} {
  catch {
	.debugwin.f0.text configure -state normal
	.debugwin.f0.text insert end "$text\n"
	.debugwin.f0.text see end
	.debugwin.f0.text configure -state disabled
  }
}

proc client:disconnect {} {
global jabber user
  set jabber(con) 0
  tk_messageBox -title "Disconnected!" -message "Server '$user(serv)' closed connection."
}

proc client:roster {stat} {
global jabber roster Tree

  if {$stat == "BEGIN_ROSTER"} {
	#Clear our roster
	foreach jid $roster(users) {
		foreach res $roster(users,$jid) {
			catch { unset pres(type,$jid/$res)   }
			catch { unset pres(status,$jid/$res) }
			catch { unset pres(pri,$jid/$res)    }
			catch { unset pres(meta,$jid/$res)   }
			catch { unset pres(icon,$jid/$res)   }
			catch { unset pres(show,$jid/$res)   }
			catch { unset pres(loc,$jid/$res)    }
			catch { unset pres(x,$jid/$res)      }
		}

		catch { unset roster(users,$jid) }
		catch { unset roster(group,$jid) }
		catch { unset roster(name,$jid)  }
		catch { unset roster(subsc,$jid) }
		catch { unset roster(ask,$jid)   }
	}
	#Clear roster in Tree widget
	foreach a $Tree(.win.f0.tree:\{\}:children) {
		Tree:delitem .win.f0.tree [list "" $a]
	}
	set jabber(in_roster) 1
  } elseif {$stat == "END_ROSTER"} {
	set jabber(in_roster) 0
  }
}

proc client:roster_item {jid name grps subsc ask} {
global jabber roster Tree

  if !$jabber(in_roster) {return}

LOG "(client:roster_item) jid:'$jid' name:'$name' grps:'$grps' subsc:'$subsc' ask:'$ask'"

  set a ""
  foreach grp $grps {
	if {$grp != ""} {lappend a $grp}
  }
  set grps $a

  if {[lsearch $roster(users) $jid] == -1} {lappend roster(users) $jid}
  set roster(users,$jid) ""
  set roster(name,$jid)  $name
  set roster(group,$jid) $grps
  set roster(subsc,$jid) $subsc
  set roster(ask,$jid)   $ask

  foreach grp $grps {
	if {[lsearch $Tree(.win.f0.tree:\{\}:children) $grp] == -1} {
		Tree:newitem .win.f0.tree [list "" $grp]
	}
	Tree:newitem .win.f0.tree [list "" $grp $jid] -text $name
  }
  update:usericon $jid
}

proc client:roster_push {jid name grps subsc ask} {
global jabber roster Tree

LOG "(client:roster_push) jid:'$jid' name:'$name' grps:'$grps' subsc:'$subsc' ask:'$ask'"
#  tk_messageBox -title "Debug" -message "Roster_push received!\nJID: '$jid'\nName: '$name'\nGroups: $grps\nSubscription: '$subsc'\nAsk: '$ask'"

  set a ""
  foreach grp $grps {
	if {$grp != ""} {lappend a $grp}
  }
  set grps $a

  if {[lsearch $roster(users) $jid] == -1} {
	lappend roster(users) $jid
	set roster(users,$jid) ""
  }
  set roster(name,$jid)  $name
  set roster(group,$jid) $grps
  set roster(subsc,$jid) $subsc
  set roster(ask,$jid)   $ask

  foreach tgrp $Tree(.win.f0.tree:\{\}:children) {
	if {[lsearch $Tree(.win.f0.tree:[list "" $tgrp]:children) $jid] != -1 && [lsearch $grps $tgrp] == -1} {
		Tree:delitem .win.f0.tree [list "" $tgrp $jid]
	}
  }
  foreach grp $grps {
	if {[lsearch $Tree(.win.f0.tree:\{\}:children) $grp] == -1} {
		Tree:newitem .win.f0.tree [list "" $grp]
	}
	if {[lsearch $Tree(.win.f0.tree:[list "" $grp]:children) $jid] == -1} {
		Tree:newitem .win.f0.tree [list "" $grp $jid] -text $name
	}
  }
  update:usericon $jid
}

proc client:presence {from type xlist args} {
global roster pres

  set a   [zabber:splitjid $from]
  set jid [lindex $a 0]
  set res [lindex $a 1]

  foreach {attr val} $args {
	switch -- $attr {
	      -status {set stat $val}
	    -priority {set pri  $val}
		-meta {set meta $val}
		-icon {set icon $val}
		-show {set show $val}
		-loc  {set loc  $val}
	}
  }

  if {$type == "subscribe"}    {
	if [info exists stat] {
		subscribewin $from $stat
	} else {
		subscribewin $from "No reason given"
	}
	return
  }
  if {$type == "subscribed"}   {tk_messageBox -title "Debug" -message "User $from allowed you to subscribe to his/her presence."; return}
  if {$type == "unsubscribe"}  {tk_messageBox -title "Debug" -message "User $from wanted to unsubscribe from your presence."; return}
  if {$type == "unsubscribed"} {tk_messageBox -title "Debug" -message "You are unsubscribed from $from 's presence."; return}

  # Do not accept presences from unknown jids
  if {[lsearch $roster(users) $jid] == -1} {return}

  # Create presence if it doesn't exist
  if {[lsearch $roster(users,$jid) $res] == -1} {
	lappend roster(users,$jid) $res

	set pres(type,$jid/$res)   "unavailable"
	set pres(status,$jid/$res) ""
	set pres(pri,$jid/$res)    0
	set pres(meta,$jid/$res)   ""
	set pres(icon,$jid/$res)   ""
	set pres(show,$jid/$res)   ""
	set pres(loc,$jid/$res)    ""
	set pres(x,$jid/$res)      ""

	foreach grp $roster(group,$jid) {
		catch {Tree:newitem .win.f0.tree [list "" $grp $jid $res] -image ioffline}
		Tree:cfgitem .win.f0.tree [list "" $grp $jid $res] -image ioffline
	}
  }

  if {$type == "unavailable"} {
	set pres(type,$jid/$res) "unavailable"
  } else {
	set pres(type,$jid/$res) ""
  }

  if [info exists stat] {set pres(status,$jid/$res) $stat }
  if [info exists pri ] {set pres(pri,$jid/$res)    $pri  }
  if [info exists meta] {set pres(meta,$jid/$res)   $meta }
  if [info exists icon] {set pres(icon,$jid/$res)   $icon }
  if [info exists show] {set pres(show,$jid/$res)   $show }
  if [info exists loc ] {set pres(loc,$jid/$res)    $loc  }

  update:resourceicon $jid $res
  update:usericon $jid
}

proc client:message {from type subject body extbody thread pri x} {
  receivemsgwin $from $thread $pri $subject $body
}

proc update:usericon {jid} {
global roster pres

  if {[lsearch $roster(users) $jid] == -1} {return}

  # If not subscribed to user, show him/her with unknown icon.
  if {$roster(subsc,$jid) != "to" && $roster(subsc,$jid) != "both"} {
	# Update tree
	if {$roster(name,$jid) == ""} {
		set name $jid
	} else {
		set name $roster(name,$jid)
	}
	foreach grp $roster(group,$jid) {
		catch {Tree:newitem .win.f0.tree [list "" $grp]}
		catch {Tree:newitem .win.f0.tree [list "" $grp $jid] -image iunknown -text "$name (Not subscribed to)"}
		Tree:cfgitem .win.f0.tree [list "" $grp $jid] -image iunknown -text "$name (Not subscribed to)"
	}
	return
  }

  # Construct a list of $jid's resources and their priorities
  # Do not add priorities<0 (pagers, etc.)
  set list ""
  foreach res $roster(users,$jid) {
	if {$pres(pri,$jid/$res) >= 0} {
		lappend list [list $res $pres(pri,$jid/$res)]
	}
  }

  # Sort list on priority
  set list [lsort -integer -decreasing -index 1 $list]

  # Decide jid's icon and the status text to be appended to it's name (such as
  # showing an away user named "Foo Bar" as "Foo Bar (Away)")
  if {$list == ""} {
	set icon ioffline
	set stat ""
  } else {
	set res [lindex [lindex $list 0] 0]

	set a [zabber:get_resource_show $jid $res]
	set icon [lindex $a 0]
	set stat [lindex $a 1]
  }

  # Update tree
  if {$roster(name,$jid) == ""} {
	set name $jid
  } else {
	set name $roster(name,$jid)
  }

  foreach grp $roster(group,$jid) {
	catch {Tree:newitem .win.f0.tree [list "" $grp]}
	catch {Tree:newitem .win.f0.tree [list "" $grp $jid] -image $icon -text "$name$stat"}
	Tree:cfgitem .win.f0.tree [list "" $grp $jid] -image $icon -text "$name$stat"
  }
}

proc update:resourceicon {jid res} {
global roster pres

  if {[lsearch $roster(users)      $jid] == -1} {return}
  if {[lsearch $roster(users,$jid) $res] == -1} {return}

  set a [zabber:get_resource_show $jid $res]
  set icon [lindex $a 0]
  set text "$res[lindex $a 1]"

  foreach grp $roster(group,$jid) {
	catch {Tree:newitem .win.f0.tree [list "" $grp $jid $res] -image $icon -text $text}
	Tree:cfgitem .win.f0.tree [list "" $grp $jid $res] -image $icon -text $text
  }
}

proc zabber:get_resource_show {jid res} {
global pres

  if ![info exists pres(type,$jid/$res)] {return [list ioffline ""]}

  set type $pres(type,$jid/$res)
  if {$type == "unavailable"} {return [list ioffline ""]}

  set icon $pres(icon,$jid/$res)
  set show $pres(show,$jid/$res)

  switch -- $show {
	  away {set rtext " (Away)"; set ricon iaway}
	  busy {set rtext " (Busy)"; set ricon iaway}
	   dnd {set rtext " (DND)" ; set ricon iaway}
       default {set rtext ""       ; set ricon ionline}
  }
  switch -- $icon {
	 happy {set rtext " (Happy)"    }
	coding {set rtext " (Coding)"   }
      sleeping {set rtext " (Sleeping)" }
       playing {set rtext " (Playing)"  }
	eating {set rtext " (Eating)"   }
	   sad {set rtext " (Sad)"      }
	 angry {set rtext " (Angry)"    }
  }

  return [list $ricon $rtext]
}

# This proc splits the given jid to username and resource.
proc zabber:splitjid {jid} {

  set idx [string first / $jid]
  if {$idx == -1} {return [list $jid ""]}

  set user [string range $jid 0 [expr $idx - 1]]
  set res  [string range $jid [expr $idx + 1] end]

  return [list $user $res]
}

# Compare two resources' priorities.
# Called from the tree widget.
proc zabber:compare_resource {jid res1 res2} {
global pres

  set pri1 0; set pri2 0

  if [info exists pres(pri,$jid/$res1)] {set pri1 $pres(pri,$jid/$res1) }
  if [info exists pres(pri,$jid/$res2)] {set pri1 $pres(pri,$jid/$res2) }

  if {$pri1 < $pri2} {return -1} \
    elseif {$pri1 > $pri2} {return 1}

  return 0
}
