proc mainwindow {} {
global pres

  ###################
  # CREATING WIDGETS
  ###################
  toplevel .win -class toplevel -menu .win.m
  wm transient .win .
  wm focusmodel .win passive
  wm geometry .win 150x200
  wm overrideredirect .win 0
  wm resizable .win 1 1
  wm deiconify .win
  wm title .win "zABBER 0.8.1"

  wm protocol .win WM_DELETE_WINDOW {jlib::disconnect; exit}

  frame       .win.f0      -width 1 -height 1 -relief sunken -bd 2
  Tree:create .win.f0.tree -width 1 -height 1 -yscrollcommand ".win.f0.scr set" -bg #ffffff
  scrollbar   .win.f0.scr  -orient vert -command ".win.f0.tree yview"
  frame       .win.f1      -bd 2 -relief groove 
  label       .win.f1.l0   -bd 0 -padx 2 -pady 2 -text "Status"
  menubutton  .win.f1.stat \
		-activebackground #ffffff -anchor w -background #ffffff \
		-disabledforeground #000000 -highlightbackground #ffffff \
		-menu .win.f1.stat.m -pady 0 -relief sunken \
		-text Offline
  menu        .win.f1.stat.m -tearoff 0

  .win.f1.stat.m add radiobutton -label Online    -value "online"    -variable pres(show) -command {zabber:set_pres "type"}
  .win.f1.stat.m add radiobutton -label Away      -value "away"      -variable pres(show) -command {zabber:set_pres "type"}
  .win.f1.stat.m add radiobutton -label Busy      -value "busy"      -variable pres(show) -command {zabber:set_pres "type"}
  .win.f1.stat.m add radiobutton -label DND       -value "dnd"       -variable pres(show) -command {zabber:set_pres "type"}
  .win.f1.stat.m add radiobutton -label Invisible -value "invisible" -variable pres(show) -command {zabber:set_pres "type"}
  .win.f1.stat.m add radiobutton -label Offline   -value "offline"   -variable pres(show) -command {zabber:set_pres "type"}

  label .win.f1.l1 -text "" -bd 0 -padx 5 -pady 2
  spinbutton .win.f1.spin -bd 1 -limit {-25 25} -entbackground #ffffff -command {set pres(pri) [.win.f1.spin get]; zabber:set_pres "pri"}

  .win.f1.spin set $pres(pri)

  ###################
  # SETTING MENUS
  ###################
  menu .win.m

  menu .win.m.jabber -tearoff 0
  menu .win.m.roster -tearoff 0
  menu .win.m.jabber.con -tearoff 0

  .win.m add cascade -label Jabber -underline 0 -menu .win.m.jabber
  .win.m add cascade -label Roster -underline 0 -menu .win.m.roster

  .win.m.jabber add cascade -label Status    -menu .win.f1.stat.m
  .win.m.jabber add cascade -label Condition -menu .win.m.jabber.con
  .win.m.jabber add separator
  .win.m.jabber add command -label "Preferences"
  .win.m.jabber add separator
  .win.m.jabber add command -label "Exit" -command {jlib::disconnect; exit}

  .win.m.jabber.con add radiobutton -label "Happy"    -value happy    -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Coding"   -value coding   -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Sleeping" -value sleeping -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Playing"  -value playing  -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Eating"   -value eating   -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Normal"   -value normal   -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Sad"      -value sad      -variable pres(icon) -command {zabber:set_pres "icon"}
  .win.m.jabber.con add radiobutton -label "Angry"    -value angry    -variable pres(icon) -command {zabber:set_pres "icon"}

  .win.m.roster add command -label "Add New User" -state disabled -command {adduserwin "" ""}
  .win.m.roster add separator
  .win.m.roster add command -label "Delete Group" -state disabled
  .win.m.roster add command -label "Delete User"  -state disabled
  .win.m.roster add separator
  .win.m.roster add command -label "Reload Roster" -state disabled -command {jlib::roster_get -command "client:roster"}

  ###################
  # SETTING GEOMETRY
  ###################
  pack .win.f0      -anchor center -expand 1 -fill both -side top
  pack .win.f0.tree -anchor center -expand 1 -fill both -side left
  pack .win.f0.scr  -anchor center -expand 0 -fill y    -side left
  pack .win.f1      -anchor center -expand 0 -fill x    -side top
  pack .win.f1.l0   -anchor center -expand 0 -fill none -side left
  pack .win.f1.stat -anchor center -expand 1 -fill x    -side left -pady 1
  pack .win.f1.l1   -anchor center -expand 0 -fill none -side left
  pack .win.f1.spin -anchor center -expand 0 -fill none -side left -pady 1
}

proc debugwin {} {
global jabber

  ###################
  # CREATING WIDGETS
  ###################
  toplevel .debugwin -class Toplevel
  wm focusmodel .debugwin passive
  wm geometry .debugwin 300x200
  wm overrideredirect .debugwin 0
  wm resizable .debugwin 1 1
  wm deiconify .debugwin
  wm title .debugwin "Debug Window"
  wm protocol .debugwin WM_DELETE_WINDOW {wm withdraw .debugwin}

  frame .debugwin.f0 -bd 2 -relief sunken 
  text .debugwin.f0.text -height 1 -width 1 -relief flat -state disabled \
    -yscrollcommand {.debugwin.f0.scroll set} -wrap char -bg #BCBCBC
  scrollbar .debugwin.f0.scroll -orient vertical -command {.debugwin.f0.text yview}

  ###################
  # SETTING GEOMETRY
  ###################
  pack .debugwin.f0        -anchor center -expand 1 -fill both -side top
  pack .debugwin.f0.text   -anchor center -expand 1 -fill both -side left
  pack .debugwin.f0.scroll -anchor center -expand 0 -fill y    -side left
}

proc adduserwin {group jid} {
  if [winfo exists .adduser] {
    wm deiconify .adduser; return
  }

  set groups [zabber:getgroups]
  ###################
  # CREATING WIDGETS
  ###################
  toplevel .adduser -class Toplevel
  wm focusmodel .adduser passive
  wm geometry .adduser 375x170
  wm overrideredirect .adduser 0
  wm resizable .adduser 0 0
  wm deiconify .adduser
  wm title .adduser "Add User to Roster"
  frame .adduser.f -height 1 -width 1
  label .adduser.f.l1 -borderwidth 0 -text {Select Group:}
  label .adduser.f.l2 -borderwidth 0 -text {Jabber User ID:}
  label .adduser.f.l3 -borderwidth 0 -text {Friendly Name:}
  combobox .adduser.f.group -width 1 -editable true -value $group -background #ffffff
    foreach grp $groups {.adduser.f.group list insert end $grp}
  entry .adduser.f.jid -width 0
    .adduser.f.jid insert end $jid
  entry .adduser.f.name -width 0
  frame .adduser.f.f1 -borderwidth 2 -height 70 -relief sunken -width 1
  text .adduser.f.f1.reason -borderwidth 0 -height 1 -relief flat -width 1 -yscrollcommand {.adduser.f.f1.scr set}
  scrollbar .adduser.f.f1.scr -command {.adduser.f.f1.reason yview} -orient vert
  frame .adduser.f.f2 -height 1 -width 1
  frame .adduser.f.f2.f -borderwidth 1 -height 1 -relief sunken -width 1
  button .adduser.f.f2.f.add -borderwidth 1 -padx 0 -pady 0 -text {Add User} -command {adduserwin:add}
  button .adduser.f.f2.f.cancel -borderwidth 1 -padx 0 -pady 0 -text {Cancel} -command {destroy .adduser}
  label .adduser.f.l4 -borderwidth 0 -text {Please Enter Reason:}
  frame .adduser.f.f0 -height 1 -relief groove -width 10

  ###################
  # SETTING GEOMETRY
  ###################
  pack .adduser.f -anchor center -expand 1 -fill both -padx 10 -pady 10 -side top
  grid columnconf .adduser.f 1 -weight 1
  grid rowconf .adduser.f 4 -weight 1
  grid .adduser.f.l1 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky w
  grid .adduser.f.l2 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky w
  grid .adduser.f.l3 -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky w
  grid .adduser.f.group -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ew
  grid .adduser.f.jid -column 1 -row 1 -columnspan 1 -rowspan 1 -sticky ew
  grid .adduser.f.name -column 1 -row 2 -columnspan 1 -rowspan 1 -sticky ew
  grid .adduser.f.f1 -column 0 -row 4 -columnspan 4 -rowspan 1 -sticky nesw
  grid columnconf .adduser.f.f1 0 -weight 1
  grid rowconf .adduser.f.f1 0 -weight 1
  grid .adduser.f.f1.reason -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
  grid .adduser.f.f1.scr -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns
  grid .adduser.f.f2 -column 3 -row 0 -columnspan 1 -rowspan 3 -ipadx 5 -sticky nesw
  grid columnconf .adduser.f.f2 0 -weight 1
  grid .adduser.f.f2.f -column 0 -row 0 -columnspan 1 -rowspan 1 -ipadx 15
  grid columnconf .adduser.f.f2.f 0 -weight 1
  grid rowconf .adduser.f.f2.f 0 -weight 1
  grid rowconf .adduser.f.f2.f 1 -weight 1
  grid .adduser.f.f2.f.add -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
  grid .adduser.f.f2.f.cancel -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky nesw
  grid .adduser.f.l4 -column 0 -row 3 -columnspan 3 -rowspan 1 -sticky sw
  grid .adduser.f.f0 -column 2 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
}

proc adduserwin:add {} {
global jabber roster
  if ![winfo exists .adduser] {return}

  set group [.adduser.f.group get]
  set jid   [.adduser.f.jid   get]
  set name  [.adduser.f.name  get]
  set req_reason [.adduser.f.f1.reason get 1.0 end]

  if {$group == "" || $jid == ""} {return}

  wm protocol .adduser WM_DELETE_WINDOW { }
  .adduser.f.f2.f.add    configure -state disabled
  .adduser.f.f2.f.cancel configure -state disabled

  if {[lsearch $roster(users) $jid] != -1} {
	if {[lsearch $roster(group,$jid) $group] != -1} {
		tk_messageBox -message "User already exists in group '$group' as '$roster(name,$jid)'!"
		wm protocol .adduser WM_DELETE_WINDOW {}
		.adduser.f.f2.f.add    configure -state normal
		.adduser.f.f2.f.cancel configure -state normal
	} else {
		lappend roster(group,$jid) $group
		update:usericon $jid
		if {$name != $roster(name,$jid)} {
			if {$roster(name,$jid) != ""} {
				set name $roster(name,$jid)
			} else {
				set name $jid
			}
			tk_messageBox -message "User already exists in other groups as '$name', so adding user to group '$group' as '$name'."
		}
		jlib::roster_set $jid -name $roster(name,$jid) -groups $roster(group,$jid) -command {adduserwin:cback}
	}
  } else {
	set jabber(addusr) 0
	jlib::roster_set $jid -name $name -groups [list $group] -command {adduserwin:cback}
	tkwait variable jabber(addusr)

	if {$jabber(addusr) != 1} {
		tk_messageBox -message "Error occured while adding user to roster!"
		wm protocol .adduser WM_DELETE_WINDOW {}
		.adduser.f.f2.f.add    configure -state normal
		.adduser.f.f2.f.cancel configure -state normal
		return
	}
	lappend $roster(users) $jid
	set roster(users,$jid) ""
	set roster(group,$jid) [list $group]
	set roster(name,$jid)  $name
	set roster(subsc,$jid) "none"
	set roster(ask,$jid)   "subscribe"

	jlib::send_presence -to $jid -type "subscribe" -stat $req_reason
  }

  wm protocol .adduser WM_DELETE_WINDOW {}
  .adduser.f.f2.f.cancel configure -state normal -text {Close} -command {destroy .adduser}
}

proc adduserwin:cback {type} {
global jabber

  if {$type == "OK"} {set jabber(addusr) 1} \
    else {set jabber(addusr) -1}
}

proc subscribewin {jid reason} {
  if [winfo exists .subscribe] {tkwait window .subscribe}

  ###################
  # CREATING WIDGETS
  ###################
  toplevel .subscribe -class Toplevel -bd 5
  wm focusmodel .subscribe passive
  wm geometry .subscribe 295x135
  wm overrideredirect .subscribe 0
  wm resizable .subscribe 0 0
  wm deiconify .subscribe
  wm title .subscribe "Authorization Request"
  wm protocol .subscribe WM_DELETE_WINDOW { }

  frame .subscribe.f0 -borderwidth 2 -height 75 -relief sunken -width 125
  text .subscribe.f0.t -wrap word -background #BCBCBC -borderwidth 0 -height 1 -relief flat -width 1 -yscrollcommand {.subscribe.f0.scr set}
  scrollbar .subscribe.f0.scr -command {.subscribe.f0.t yview} -orient vert
  frame .subscribe.f1 -borderwidth 1 -height 25 -relief sunken -width 1
  button .subscribe.f1.b0 -borderwidth 1 -padx 0 -pady 0 -text {User Info}
  button .subscribe.f1.b1 -borderwidth 1 -padx 0 -pady 0 -text {Decline User}   -command {destroy .subscribe}
  button .subscribe.f1.b2 -borderwidth 1 -padx 0 -pady 0 -text {Authorize User} -command "jlib::send_presence -to [list $jid] -type {subscribed}; destroy .subscribe"
  ###################
  # SETTING GEOMETRY
  ###################
  grid columnconf .subscribe 0 -weight 1
  grid rowconf .subscribe 0 -weight 1
  grid .subscribe.f0 -column 0 -row 0 -columnspan 1 -rowspan 1 -pady 3 -sticky nesw
  grid columnconf .subscribe.f0 0 -weight 1
  grid rowconf .subscribe.f0 0 -weight 1
  grid .subscribe.f0.t -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
  grid .subscribe.f0.scr -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns
  grid .subscribe.f1 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky nesw
  grid columnconf .subscribe.f1 0 -weight 1
  grid columnconf .subscribe.f1 1 -weight 1
  grid columnconf .subscribe.f1 2 -weight 1
  grid rowconf .subscribe.f1 0 -weight 1
  grid .subscribe.f1.b0 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
  grid .subscribe.f1.b1 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
  grid .subscribe.f1.b2 -column 2 -row 0 -columnspan 1 -rowspan 1 -sticky nesw

  .subscribe.f0.t insert end "User [string range $jid [expr [string first : $jid]+1] end] wants to add you to his/her roster.\n---\n"
  .subscribe.f0.t insert end $reason

  grab set .subscribe
  tkwait window .subscribe
}

proc bgerror {message} {
global errorInfo errorCode

  toplevel .bgerror -class toplevel
  wm transient .bgerror .
  wm focusmodel .bgerror passive
  wm overrideredirect .bgerror 0
  wm deiconify .bgerror
  wm title .bgerror "Background Error!"
  wm protocol .bgerror WM_DELETE_WINDOW { }

  label .bgerror.l -text "A background error occured. Please e-mail the following information to\ntcl-dev@jabber.org,\ntelling what you were doing when it happened." -justify center -bd 0

  frame .bgerror.f -bd 2 -relief sunken
  text .bgerror.f.t -bd 0 -relief flat -width 1 -height 15 -yscrollcommand ".bgerror.f.s set"
  scrollbar .bgerror.f.s -command ".bgerror.f.t yview"

  button .bgerror.b -text "CLOSE WINDOW" -command "destroy .bgerror"
  pack .bgerror.l -side top -fill x -padx 5 -pady 5
  pack .bgerror.f -side top -fill both -expand 1 -padx 5
  pack .bgerror.f.t -side left -fill both -expand 1
  pack .bgerror.f.s -side left -fill y
  pack .bgerror.b -side top -fill x -padx 5 -pady 5

  .bgerror.f.t insert end "---- BEGIN ---\n"
  .bgerror.f.t insert end "$message\n"
  .bgerror.f.t insert end "code: $errorCode\n\n"
  .bgerror.f.t insert end "$errorInfo"
  .bgerror.f.t insert end "---- END ---\n"
  .bgerror.f.t see 1.0
  .bgerror.f.t configure -state disabled

  wm resizable .bgerror 0 0

  focus -force .bgerror
  grab set .bgerror
  tkwait window .bgerror
}

proc receivemsgwin {from thread pri subject body} {

    set w ".receivemsg"
    set num 0
    while {[winfo exists $w$num]} {incr num}
    set w $w$num

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $w -class Toplevel
    wm focusmodel $w passive
    wm geometry $w 340x135
    wm minsize $w 340 135
    wm overrideredirect $w 0
    wm resizable $w 1 1
    wm deiconify $w
    wm title $w "Message Received from '$from'"
    frame $w.f0 -borderwidth 1 -height 1 -width 1
    label $w.f0.lfrom -anchor e -borderwidth 0 -text {From: }
    entry $w.f0.from -borderwidth 1 -width 1 -bg [$w.f0 cget -bg]
    label $w.f0.lthread -anchor e -borderwidth 0 -text {  Thread: }
    entry $w.f0.thread -borderwidth 1 -width 4 -bg [$w.f0 cget -bg]
    label $w.f0.lpri -anchor e -borderwidth 0 -text {  Priority: }
    spinbutton $w.f0.pri -borderwidth 1 -justify right -width 2 -entbackground [$w.f0 cget -bg]
    frame $w.f0.f -borderwidth 2 -height 3 -width 1
    label $w.f0.lsub -anchor e -borderwidth 0 -text {Subject: }
    entry $w.f0.subject -borderwidth 1 -width 0 -bg [$w.f0 cget -bg]
    frame $w.f1 -borderwidth 2 -height 1 -relief sunken -width 1
    text $w.f1.t -borderwidth 0 -height 1 -relief flat -width 1 -yscrollcommand "$w.f1.s set" -bg [$w.f0 cget -bg]
    scrollbar $w.f1.s -command "$w.f1.t yview"
    frame $w.f2 -borderwidth 1 -height 27 -relief sunken -width 1
    button $w.f2.reply -borderwidth 1 -text Reply -command "sendmsgwin [list $from $thread $pri Re:$subject]; destroy $w"
    button $w.f2.fwd -borderwidth 1 -text Forward -state disabled
    button $w.f2.next -borderwidth 1 -text OK -command "destroy $w"

    ###################
    # SETTING GEOMETRY
    ###################
    grid columnconf $w    0 -weight 1
    grid columnconf $w.f0 1 -weight 15
    grid columnconf $w.f0 3 -weight 2
    grid columnconf $w.f0 5 -weight 1
    grid columnconf $w.f1 0 -weight 1
    grid rowconf    $w    1 -weight 1
    grid rowconf    $w.f1 0 -weight 1

    grid $w.f0 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lfrom -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.from -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lthread -column 2 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.thread -column 3 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lpri -column 4 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.pri -column 5 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lsub -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.subject -column 1 -row 2 -columnspan 5 -rowspan 1 -sticky ew
    grid $w.f0.f -column 0 -row 1 -columnspan 6 -rowspan 1 -sticky ew
    grid $w.f1 -column 0 -row 1 -columnspan 1 -rowspan 1 -pady 2 -sticky nesw
    grid $w.f1.t -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
    grid $w.f1.s -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns
    grid $w.f2 -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky ew
    place $w.f2.next -x 1 -relx 0.66 -y 1 -width 1 -relwidth 0.33 -height -2 -relheight 1 -anchor nw -bordermode ignore
    place $w.f2.fwd -x 1 -relx 0.33 -y 1 -width 0 -relwidth 0.33 -height -2 -relheight 1 -anchor nw -bordermode ignore
    place $w.f2.reply -x 1 -y 1 -width 0 -relwidth 0.33 -height -2 -relheight 1 -anchor nw -bordermode ignore

    ###################
    # SETTING VALUES
    ###################
    $w.f0.from insert end $from
    $w.f0.thread insert end $thread
    $w.f0.pri set $pri
    $w.f0.subject insert end $subject
    $w.f1.t insert end $body

    $w.f0.from    configure -state disabled
    $w.f0.thread  configure -state disabled
    $w.f0.pri     configure -state disabled
    $w.f0.subject configure -state disabled
    $w.f1.t       configure -state disabled
}

proc sendmsgwin {to {thread ""} {pri 0} {subject ""} {body ""}} {
    set w ".[escapewindowname sendmsg_$to]"

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $w -class Toplevel
    wm focusmodel $w passive
    wm geometry $w 340x135
    wm minsize $w 340 135
    wm overrideredirect $w 0
    wm resizable $w 1 1
    wm deiconify $w
    wm title $w "Send Message To: $to"
    frame $w.f0 -borderwidth 1 -height 1 -width 1
    label $w.f0.lto -anchor e -borderwidth 0 -text {To: }
    entry $w.f0.to -borderwidth 1 -width 1 -bg [$w.f0 cget -bg]
    label $w.f0.lthread -anchor e -borderwidth 0 -text {  Thread: }
    entry $w.f0.thread -borderwidth 1 -width 4
    label $w.f0.lpri -anchor e -borderwidth 0 -text {  Priority: }
    spinbutton $w.f0.pri -borderwidth 1 -justify right -width 2
    frame $w.f0.f -borderwidth 2 -height 3 -width 1
    label $w.f0.lsub -anchor e -borderwidth 0 -text {Subject: }
    entry $w.f0.subject -borderwidth 1 -width 0
    frame $w.f1 -borderwidth 2 -height 1 -relief sunken -width 1
    text $w.f1.t -borderwidth 0 -height 1 -relief flat -width 1 -yscrollcommand "$w.f1.s set"
    scrollbar $w.f1.s -command "$w.f1.t yview"
    frame $w.f2 -borderwidth 1 -height 27 -relief sunken -width 1
    button $w.f2.cancel -borderwidth 1 -text Cancel -command "destroy $w"
    button $w.f2.send -borderwidth 1 -text Send -command "sendmsg $w"

    ###################
    # SETTING GEOMETRY
    ###################
    grid columnconf $w    0 -weight 1
    grid columnconf $w.f0 1 -weight 15
    grid columnconf $w.f0 3 -weight 2
    grid columnconf $w.f0 5 -weight 1
    grid columnconf $w.f1 0 -weight 1
    grid rowconf    $w    1 -weight 1
    grid rowconf    $w.f1 0 -weight 1

    grid $w.f0 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lto -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.to -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lthread -column 2 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.thread -column 3 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lpri -column 4 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.pri -column 5 -row 0 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.lsub -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky ew
    grid $w.f0.subject -column 1 -row 2 -columnspan 5 -rowspan 1 -sticky ew
    grid $w.f0.f -column 0 -row 1 -columnspan 6 -rowspan 1 -sticky ew
    grid $w.f1 -column 0 -row 1 -columnspan 1 -rowspan 1 -pady 2 -sticky nesw
    grid $w.f1.t -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw
    grid $w.f1.s -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns
    grid $w.f2 -column 0 -row 2 -columnspan 1 -rowspan 1 -sticky ew
    place $w.f2.send -x 1 -relx 0.66 -y 1 -width 1 -relwidth 0.33 -height -2 -relheight 1 -anchor nw -bordermode ignore
    place $w.f2.cancel -x 1 -y 1 -width 0 -relwidth 0.33 -height -2 -relheight 1 -anchor nw -bordermode ignore

    ###################
    # SETTING VALUES
    ###################
    $w.f0.to insert end $to
    $w.f0.thread insert end $thread
    $w.f0.pri set $pri
    $w.f0.subject insert end $subject
    $w.f1.t insert end $body

    $w.f0.to configure -state disabled
}

proc sendmsg {w} {
  set to     [$w.f0.to get]
  set thread [$w.f0.thread get]
  set pri    [$w.f0.pri get]
  set subje  [$w.f0.subject get]
  set body   [$w.f1.t get 1.0 end]

  jlib::send_msg $to -subject $subje -body $body -thread $thread -priority $pri
  destroy $w
}

proc escapewindowname {name} {
  regsub -all {([_])} $name __ name
  regsub -all {([.])} $name _a name
  regsub -all {([ ])} $name _b name
  return "a_$name"  ;# this line prevents windownames starting with capital letter
}
